package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.*;
import java.util.*;
import java.awt.*;  
import javax.swing.*;

class CustomRGBLUT extends JFrame implements java.awt.event.ActionListener, java.awt.event.WindowListener{
	int width=256,height=256;
	RGBLUTCanvas canvas;
	boolean ifWritePostscriptFile=false;

	public CustomRGBLUT() {
		super("Look Up Table editor");
		setBackground(new Color(64, 0, 64));
		getContentPane().setLayout(new BorderLayout());
		setSize(256+16,256+32);
		canvas = new RGBLUTCanvas(this);
		getContentPane().add("Center",canvas);
		getContentPane().add("North",makeAJButton("postscript output"));
		addWindowListener(this);
		}
	
  	private JButton makeAJButton(String lab) {
		JButton bt = new JButton(lab);
		bt.addActionListener(this);
		return bt;
		}
		
    	
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
	    	if(arg.equals("postscript output")) {
				ifWritePostscriptFile=true;
    			}
    		return;
    	}
	
static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
	// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
	    setVisible(false);
	    dispose();
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}

	public void paint(Graphics g) {
		//talk("This should never happen. CustomRGBLUT.paint() called");
		paint2D((Graphics2D)g);
		}
		
	public void update(Graphics g) {
		// talk("CustomRGBLUT.update() called. Should never happen");
		paint2D((Graphics2D)g);
		}

	public void update2D(Graphics2D g) {
		paint2D(g);
		}

	public void paint2D(Graphics2D g) {
		width = getSize().width;		
		height = getSize().height;
		g.setColor(new Color(64, 0, 64));
		g.fillRect(0, 0, width, height);
		canvas.paint2D(g, true);
		}		
		
	public int [] getRedLUT() {
		return canvas.getRedLUT();
		}
	public int [] getGreenLUT() {
		return canvas.getGreenLUT();
		}
	public int [] getBlueLUT() {
		return canvas.getBlueLUT();
		}
	
	public void acceptNewRedLUT(int [] LUT) {
	    for(int i=0;i<256;i++)
		canvas.currentRedLUT[i]=LUT[i];
	    }
	
	public void acceptNewGreenLUT(int [] LUT) {
	    for(int i=0;i<256;i++)
		canvas.currentGreenLUT[i]=LUT[i];
	    }
	
	public void acceptNewBlueLUT(int [] LUT) {
	    for(int i=0;i<256;i++)
		canvas.currentBlueLUT[i]=LUT[i];
	    repaint();
	    }
	
	public void transferLUT(int src, int dst) {
	    canvas.transferLUT(src, dst);
	    }

	public void getNewLUT(int iwh) {
		canvas.getNewLUT(iwh);
		}
	
}