package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;  import javax.swing.*;
import java.applet.*;
import java.util.*; 
import java.io.*;


class JFramer extends JFrame{
	
	
	public String getDir(String prompt) {
		FileDialog getAFile = 
		   new FileDialog(this,prompt, FileDialog.LOAD);
		getAFile.show();
		return getAFile.getDirectory();
		}
		
		
	public RandomAccessFile openReadWriteFile(String filename) {
		RandomAccessFile inoutfile;
		if(filename == null) {
			talk("bad file name");
			return null;
			}
		try{
			inoutfile = new RandomAccessFile(filename,"rw");
			}
		catch (FileNotFoundException e) {
			talk("openReadWriteFile("+filename+") failed -- file not found");
			return null;
			}
		catch (IOException e) {
			talk("openReadWriteFile("+filename+") failed IOexception" + e);
			return null;
			}
		try{inoutfile.seek((long)0);}
		catch(IOException e) {};
		return inoutfile;
		}

	public RandomAccessFile openReadFile(String filename) {
		RandomAccessFile inoutfile;
		if(filename == null) {
			talk("bad file name");
			return null;
			}
		try{
			inoutfile = new RandomAccessFile(filename,"r");
			}
		catch (FileNotFoundException e) {
			talk("openReadWriteFile("+filename+") failed -- file not found");
			return null;
			}
		catch (IOException e) {
			talk("openReadWriteFile("+filename+") failed IOexception" + e);
			return null;
			}
		try{inoutfile.seek((long)0);}
		catch(IOException e) {};
		return inoutfile;
		}

	public File aPlainFile(String filename) {
		File inoutfile;
		if(filename == null) {
			talk("bad file name");
			return null;
			}
		try{
			inoutfile = new File(filename);
			}
		catch (NullPointerException e) {
			talk("aPlainFile("+filename+") failed -- file not found");
			return null;
			}
		return inoutfile;
		}

	public byte [] readTheFile(RandomAccessFile inoutfile) {
		int ngot;
		int  nbytes=0;
		
		try{nbytes = (int)inoutfile.length();}
		catch(IOException e) { 
			talk("Got bad length() IOException: "+e);
			return  null;
			}  
	
		if(nbytes==0) return null;
		byte [] theBytes = new byte[nbytes];

		try {ngot=inoutfile.read(theBytes);} // get the 16 byte header
		catch(IOException e) { 
			talk("Got RandomAccessFile IOException: "+e);
			return  null;
			} 
		try{inoutfile.seek((long)0);} // return file pointer to original start location 
		catch(IOException e) {
			talk("bad seek to beginning of e in readTheFile()");
			};
		
		return(theBytes);
		}		

	public boolean renameFile(File orig, String newFullPathName) {
		RandomAccessFile theFile= openReadWriteFile(newFullPathName);
		if(theFile != null) {
				closeOutputFile(theFile); // this just creates the new file							
			return (orig.renameTo(new File(newFullPathName)));
			}
		else return false;
		}
		
		
	public  void closeOutputFile(RandomAccessFile inoutf) {
		try{inoutf.close();} catch(IOException e) {
			talk("closeOutputFile("+inoutf+") failed ???");};
		}		

	private void talk(String p) {
		System.out.println(p);
		}
	
	

}