package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;  
import javax.swing.*;
import java.util.*;
import java.io.*;
import java.net.*;

class IPProbe implements Runnable{
	String tryThisIp;
	int portNum=0;
	Thread proberThread=null;
	int itry;
	FindServerPortOnSubnet parent;
	public IPProbe(int itry, int portNum, String iprefix, FindServerPortOnSubnet parent) {
		this.portNum=portNum;
		this.itry=itry;
		tryThisIp = (iprefix + itry);
		//talk("iprefix="+iprefix+". IPProbe for port "+portNum+" created for ip = ..."+itry+" namely "+tryThisIp);  
		this.parent=parent;
		}
	
	public void start() {
		if(proberThread==null) {
			proberThread = new Thread(this);
			proberThread.start();
			}
		}
		
	public void stop() {
		//talk("Stopping probe thread for "+tryThisIp);
		if(proberThread!=null) {
			proberThread.stop();
			}
		}

	public void run() {
		//talk("probe "+tryThisIp);
		try {
			Socket ss = new Socket(tryThisIp,portNum);
			talk("");
			talk("Made connection on <"+tryThisIp+">");
			talk("");	
			parent.gotAServerConnection(tryThisIp,ss);
			}
		catch (Exception e) {
			//talk("attempt to create socket on port "+portNum+" at <"+tryThisIp+"> failed");
			}
		stop();
		}
		
	static void talk(String p) {
		System.out.println(p);
	}	

}
