package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;

class InvertFltr {
	SegmenterNode nd=null;

	public InvertFltr(SegmenterNode nd) {
		this.nd=nd;
		}

	public void tellWhatYouDo() {
		nd.talk("");
		nd.talk("The invert filter has no parameters. It exchanges black and white. ");
		nd.talk("The output at each pixel is 255 minus the input pixel's value.");
		}
				
	public boolean doit(short [] inras, int incols, int inrows, short [] outras) {
		int i, npix = inrows*incols; 
		if(nd.diags) nd.talk("InvertFltr");
 		for(i=0;i<npix;i++)
			outras[i] = (short)(255-inras[i]);	
		return true;	
		}
}