package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  
import javax.swing.*;


class MakeA3Dmask extends JFrame implements java.awt.event.ActionListener,java.awt.event.ItemListener {
	int nomwidth=250,nomheight=150;
	int making3Dmask=1;
	Segmenter parent=null;
	JButton xysectbutton=null, xzsectbutton=null, 
		zysectbutton=null;
	String [] maskChoices = new String[] {"making new 3D mask 1 ",
							"making new 3D mask 2 ","making new 3D mask 3 ",
							"modifying old 3D mask 1 ",
							"modifying old 3D mask 2 ","modifying old 3D mask 3 "};
	JComboBox whatMaskToMake;
	boolean ifMakeXYsects=true,ifMakeXZsects=true, ifMakeZYsects=true;
	
	public MakeA3Dmask(Segmenter parent) {   
    	super("making new 3D mask maker");
    	this.parent = parent;
    	WidgetMaker wmk = new WidgetMaker(this);
    	setSize(nomwidth+1, nomheight+1);
    	Container myPane = getContentPane();
		myPane.setLayout(new GridLayout(5,1));

		JButton goButton = wmk.makeAJButton("start");
		myPane.add(goButton);
		
		whatMaskToMake = wmk.makeAJComboBox(maskChoices);
		myPane.add(whatMaskToMake);
			
		xysectbutton = wmk.makeAJButton("doing XY sects ");
		xzsectbutton = wmk.makeAJButton("doing XZ sects ");
		zysectbutton = wmk.makeAJButton("doing ZY sects ");
		myPane.add(xysectbutton);	
		myPane.add(xzsectbutton);	
		myPane.add(zysectbutton);
		getAttention();
    	goButton.setVisible(true);
    	setSize(nomwidth+2, nomheight+2);
		myPane=null;	
    	wmk=null;
  		}
  		
	public void getAttention() {
		setVisible(true);
	    setLocation(400,300);
    	setSize(nomwidth, nomheight);
    	whatMaskToMake.setVisible(true);
		}

	public void itemStateChanged(java.awt.event.ItemEvent event){
		String arg = (String)(((JComboBox)(event.getSource())).getSelectedItem());
		for(int i=0; i<6; i++)
	    	if(arg.equals(maskChoices[i])) {
			making3Dmask=i+1;
			return;
    		}
		}
		
// catch button and menu events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
      	
      	if(arg.equals("doing XY sects ")) {
      		ifMakeXYsects=false;
			xysectbutton.setLabel("omitting XY sects ");
			return;
			}
      	if(arg.equals("omitting XY sects ")) {
      		ifMakeXYsects=true;
			xysectbutton.setText("doing XY sects ");
			return;
			}
			
      	if(arg.equals("doing XZ sects ")) {
      		ifMakeXZsects=false;
			xzsectbutton.setText("omitting XZ sects ");
			return;
			}
      	if(arg.equals("omitting XZ sects ")) {
      		ifMakeXZsects=true;
			xzsectbutton.setText("doing XZ sects ");
			return;
			}
			
      	if(arg.equals("doing ZY sects ")) {
      		ifMakeZYsects=false;
			zysectbutton.setText("omitting ZY sects ");
			return;
			}
      	if(arg.equals("omitting ZY sects ")) {
      		ifMakeZYsects=true;
			zysectbutton.setText("doing ZY sects ");
			return;
			}

    	if(arg.equals("start")) {
    		if(parent.startMaking3Dmask(this)) 
    			talk("MakeA3Dmask() trigger worked");
    			
    		else 
    			talk("MakeA3Dmask() trigger failed!!!!");
    		setVisible(false);
			parent=null;
			maskChoices = null;
			dispose();
    		}
    	
    }


	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}

