package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;  
import javax.swing.*;
import java.awt.image.*;
import java.util.*;
import java.lang.*;
import java.io.*;

class MarkerShape extends JFrame  implements java.awt.event.ActionListener,java.awt.event.ItemListener,java.awt.event.WindowListener {
	ShowPicJPanel picJPanel=null;
	int nomwidth=290, nomheight=135;
	int redshape=0, greenshape=0, blueshape=0;
	String [] shape = {"rectangle","diamond","cross","X","oval","void"};
	int Nshapes=6;
	int i,redchan=0, greenchan=1, bluechan=2;
	JComboBox redChoices,greenChoices,blueChoices;
	RGBMarker myMark=null;
	boolean ignoreStateChangeItems=false;


    public MarkerShape(ShowPicJPanel picJPanel)   {   
        super("Marker Shapes");
	this.picJPanel = picJPanel;
	getContentPane().setLayout(new GridLayout(2,1));    // NEED to specify a layout manager!!
    setSize(nomwidth, nomheight);
	WidgetMaker wmk = new WidgetMaker(this);
	JPanel shapePan = new JPanel();
	shapePan.setLayout(new GridLayout(0,3));
	
	redChoices = wmk.makeAJComboBox(
		new String [] {"rectangle","diamond","cross","X","oval"});

	greenChoices = wmk.makeAJComboBox(
		new String [] {"rectangle ","diamond ","cross ","X ","oval "});
	
	blueChoices = wmk.makeAJComboBox(
		new String [] {" rectangle"," diamond"," cross"," X"," oval"});

	shapePan.add(wmk.makeAJButton("others same as",wmk.lightred));
	shapePan.add(wmk.makeAJButton("red leaf shape",wmk.lightred));	
	shapePan.add(redChoices);
	shapePan.add(wmk.makeAJButton("others same as ",wmk.lightgreen));
	shapePan.add(wmk.makeAJButton("green leaf shape",wmk.lightgreen));	
	shapePan.add(greenChoices);
	shapePan.add(wmk.makeAJButton(" others same as",wmk.lightblue));
	shapePan.add(wmk.makeAJButton("blue leaf shape", wmk.lightblue));	
	shapePan.add(blueChoices);
	
	JPanel growPan = new JPanel();
	growPan.setLayout(new GridLayout(0,4));
	Color ablue = new Color(100,255,210);
	growPan.add(wmk.makeAJButton("grow",ablue));
	growPan.add(wmk.makeAJButton("shrink",ablue));
	growPan.add(wmk.makeAJButton("Huge growth",ablue));
	growPan.add(wmk.makeAJButton("huge shrink",ablue));
	
	JPanel aspectPan = new JPanel();
	aspectPan.setLayout(new GridLayout(0,4));
	aspectPan.add(wmk.makeAJButton("Taller",ablue));
	aspectPan.add(wmk.makeAJButton("shorter",ablue));
	aspectPan.add(wmk.makeAJButton("Wider",ablue));
	aspectPan.add(wmk.makeAJButton("narrower",ablue));

	JPanel botPan = new JPanel();
	botPan.setLayout(new GridLayout(0,1));
	botPan.add(growPan);
	botPan.add(aspectPan);
	botPan.add(wmk.makeAJButton("same shapes for all other markers",Color.yellow));
	
	getContentPane().add(shapePan);
	getContentPane().add(botPan);
	addWindowListener(this);
 	}

    public void adoptNewMarker(int iwh, RGBMarker myMark) {
	this.myMark=myMark;
	setRedChoice(myMark.leaf[0].myShape);
	setGreenChoice(myMark.leaf[1].myShape);
	setBlueChoice(myMark.leaf[2].myShape);
	}

    private void setRedChoice(int iwh) {
	redshape=iwh;
	if(!ignoreStateChangeItems)
		redChoices.setSelectedIndex(redshape); 
	myMark.leaf[0].myShape=redshape;
	}
	
    private void setGreenChoice(int iwh) {
	greenshape=iwh;
	if(!ignoreStateChangeItems)
		greenChoices.setSelectedIndex(greenshape);
	myMark.leaf[1].myShape=greenshape;
	}
	
    private void setBlueChoice(int iwh) {
	blueshape=iwh;
	if(!ignoreStateChangeItems)
		blueChoices.setSelectedIndex(iwh);
	myMark.leaf[2].myShape=blueshape;
	}
	
// catch button and menu events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
	    if(arg.equals("others same as")) { // impose red shape on  and blue
			setBlueChoice(redshape);
			setGreenChoice(redshape);
			picJPanel.reDraw();
			}
	    if(arg.equals("grow")) { // impose green shape on red and blue
	    	myMark.grow();
			picJPanel.reDraw();
			}
	    if(arg.equals("shrink")) { // impose green shape on red and blue
	    	myMark.shrink();
			picJPanel.reDraw();
			}

	    if(arg.equals("Huge growth")) { // impose green shape on red and blue
	    	myMark.grow(10);
			picJPanel.reDraw();
			}
	    if(arg.equals("huge shrink")) { // impose green shape on red and blue
	    	myMark.shrink(10);
			picJPanel.reDraw();
			}

	    if(arg.equals("Taller")) { // impose green shape on red and blue
	    	myMark.boostHeight();
			picJPanel.reDraw();
			}
	    if(arg.equals("shorter")) { // impose green shape on red and blue
	    	myMark.cutHeight();
			picJPanel.reDraw();
			}
	    if(arg.equals("Wider")) { // impose green shape on red and blue
	    	myMark.boostWidth();
			picJPanel.reDraw();
			}
	    if(arg.equals("narrower")) { // impose green shape on red and blue
	    	myMark.cutWidth();
			picJPanel.reDraw();
			}
	

	    if(arg.equals("others same as ")) { // impose green shape on red and blue
		setRedChoice(greenshape);
		setBlueChoice(greenshape);
		picJPanel.reDraw();
		}
	    if(arg.equals(" others same as")) { // impose blue shape on green and red
		setRedChoice(blueshape);
		setGreenChoice(blueshape);
		picJPanel.reDraw();
		}
	    if(arg.equals("same shapes for all other markers")) { // impose blue shape on green and red
		picJPanel.allMarkersAdoptTheseLeafShapes(redshape, greenshape, blueshape);
		picJPanel.reDraw();
		}
	}

//catch Choice events...	
	public void itemStateChanged(java.awt.event.ItemEvent event) {
		// talk("MarkerShape got ItemEvent <"+(String)(event.getItem())+">");
		if(ignoreStateChangeItems) {
			// talk("        Ignore it ");
			return;
			}
		ignoreStateChangeItems=true;
		String arg = (String)(((JComboBox)(event.getSource())).getSelectedItem());

		for(int iwh=0;iwh<Nshapes;iwh++) {
	      if(arg.equals(shape[iwh])) {
				setRedChoice(iwh); // this fires another ItemEvent which we must ignore
				picJPanel.reDraw();
	    		}
	    if(arg.equals(shape[iwh]+" ")) {
			greenshape=iwh;
			setGreenChoice(iwh);
			picJPanel.reDraw();
	    	}
	    if(arg.equals(" "+shape[iwh])) {
			blueshape=iwh;
			setBlueChoice(iwh);
			picJPanel.reDraw();
	    	}
	    }
	try {Thread.sleep(100);}
	catch(InterruptedException e) {;}
	ignoreStateChangeItems=false;
	}
	
	// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
	    setVisible(false);
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}
	 
	public void changeJPanelSize(double ratio) {
		int pwidth = getSize().width;
		int pheight = getSize().height;
		pwidth = (int)(ratio*pwidth +.4999);
		pheight = (int)(ratio*pheight +.4999);
		setSize(pwidth,pheight);
		show();
		}

	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
}
