package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;  
import javax.swing.*;

public class MyDialog extends Dialog implements Runnable{
    DialogCallback	callbackClass;	// The calling class
    int				dlogID;			// The calling classes id number for this dialog, which the calling class uses when its told a dlog has finished
    boolean		good;			// This is set to true if user clicks on ok, false if user clicks on cancel
	JButton			selectJButton, cancelJButton;	// OK and Cancel buttons - derived class must make and place them

	MyDialog(JFrame parent, String title, boolean modal, DialogCallback callback_class, int dlog_id) {
		super(parent, title, modal);
		callbackClass = callback_class;
		dlogID = dlog_id;
		good = false;
		show();
	}
	
	public void dlogDone() {		// Do this in a new thread so we don't tie up the event loop
		Thread thread = new Thread(this);
		thread.start();
		}
	
	public void run() {
		callbackClass.dialogDone(this, dlogID, good);		
	}

    synchronized public boolean action(Event e, Object arg) {
        if (e.target == selectJButton ) {
            setVisible(false);         // hide the JFrame
            good = true;
            dlogDone();
            return true;
         }
         else if(e.target == cancelJButton) {
            setVisible(false);         // hide the JFrame
         	good = false;
         	dlogDone();
         	return true;
         }
        // anything else, we use the default behavior: JFrame.handleEvent()
        return super.handleEvent(e);
    }
}
