package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;

class PointSpreadCanvasFrame extends JFrame {
	writePointSpreadFile parent=null;
	int mywidth=128,myheight=256;
	PointSpreadCanvas canvas=null;
	 
	public PointSpreadCanvasFrame(writePointSpreadFile parent) {
    	super("PSF profiles");
		this.parent = parent;
		canvas = new PointSpreadCanvas(this,parent);
    	getContentPane().setLayout(new BorderLayout()); 
    	getContentPane().add("Center",canvas);
    	mywidth = canvas.canvaswidth + 20;
    	myheight = canvas.canvasheight;
   		setSize(myheight, myheight);
		showYourself(false);
		}
	
	public void sepuku() {
		parent=null;
		canvas.sepuku();
		canvas=null;
		dispose();
		}
			
	public void showYourself(boolean ifshow) {
		setVisible(ifshow);
		canvas.setVisible(ifshow);		
		}
	
	public double getCurrentZheight() {
			return (canvas.getCurrentZheight());
			}
	
	public void resetSize(int canvaswidth, int canvasheight) {
		mywidth=canvaswidth;
		myheight = canvasheight;
		setSize(mywidth,myheight);
		showYourself(true);
		}
	
	public void newSlate(double [][]radProfile, int nradpts, int numProfiles) {
		canvas.newSlate(radProfile,  nradpts,  numProfiles);
		}
}

