package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;  import javax.swing.*;
import java.awt.image.*;
import java.util.*;
import java.lang.*;
import java.io.*;

/* implements a drawing canvas that will hold a vertical column of three postage stamp images
   having text-marked spots in each of the three pictures which, if clicked, tell whether to 
   dismiss, promote to "contender" status, or pick as "current best".
   */
class SegTower extends JFrame{
	SegTowerCanvas canvas;
	Segmenter parent=null;
	int ID=-1;
	
	public SegTower(int ID, int stampWidth, int stampHeight, Segmenter parent) {
		this.parent = parent;
		this.ID = ID;
		setBackground(new Color(80,80,1));
		getContentPane().setLayout(new BorderLayout());
		canvas = new SegTowerCanvas(ID, stampWidth,stampHeight, this);
		getContentPane().add("Center",canvas);
		setSize(canvas.towerWidth,canvas.towerHeight);
		int itsX = ID*(canvas.towerWidth+12);
		int itsY=0;
		boolean shifted=false;
		while(itsX > 1024 - canvas.towerWidth/2) {
			itsX -= 1024;
			shifted=true;
			}
		if(shifted)
			itsY=250;
		setLocation(itsX,itsY);
		setVisible(true);
		setTitle("stamp tower "+ID);
		canvas.repaint();
		}
	
	public void showYourself() {
		setVisible(true);
		repaint();
		canvas.repaint();
		}
		
	public void changeStampSizes(int stampWidth,int stampHeight) {
		canvas.changeStampSizes(stampWidth,stampHeight);
		setSize(canvas.towerWidth,canvas.towerHeight);
		}
		
	public void sepuku() {
		canvas.sepuku();
		setVisible(false);
		dispose();
		}
		
		
	public void dismissAllBut(int survivingStatus) {
	    canvas.dismissAllBut(survivingStatus);
	    }

	public void newStampLocation(int stampXorig,int stampYorig) {
		canvas.newStampLocation(stampXorig,stampYorig);
		}
			
	public void emptyPics() {
		canvas.emptyPics();
		}
		
	public void noOneIsBest() {
		canvas.noOneIsBest();
		}
		
	public int firstNonContender()	{
		return canvas.firstNonContender();
		}
		
	public int firstEmptyPic()	{
		return canvas.firstEmptyPic();
		}
		
	public boolean updateTowerRas() {
		return canvas.updateTowerRas();
		}
		
	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
		
		}

