package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;


class SetMovieFrameParms extends JFrame implements java.awt.event.ActionListener,java.awt.event.WindowListener {
	ShowPicJPanel picJPanel;
	int nomwidth=150,nomheight=160;
	JTextField firstFrameText,lastFrameText,zoomText,flash1,flash2;
	JButton qualButton;	
	int jqual=0,maxframes;
	boolean leftSet=true, ifdead=false;
	
    public SetMovieFrameParms(ShowPicJPanel picJPanel,int maxframes) {   
    	super("setup jpg frames");
   		this.picJPanel = picJPanel;
    	this.maxframes = maxframes;
    	WidgetMaker wmk = new WidgetMaker(this);
    	int rr=40, gg=255, bb=90;
    	getContentPane().setLayout(new GridLayout(0,2)); 
    	setSize(nomwidth, nomheight);
    	flash1 = wmk.makeAJTextField("please",12,rr,gg,bb);
		rr += 30; gg -= 30; bb+=21;
    	flash2 = wmk.makeAJTextField("respond",12,rr,gg,bb);
		rr += 30; gg -= 30; bb+=21;
		firstFrameText=wmk.makeAJTextField("0",4,rr,gg,bb);
		rr += 30; gg -= 30; bb+=21;
		lastFrameText=wmk.makeAJTextField((""+maxframes),4,rr,gg,bb);
		rr += 30; gg -= 30; bb+=21;
		zoomText=wmk.makeAJTextField("1.00",8,rr,gg,bb);
		rr += 30; gg -= 30; bb+=21;
		qualButton=wmk.makeAJButton("perfect",rr,gg,bb);	

		getContentPane().add(flash1);
		getContentPane().add(flash2);

		getContentPane().add(wmk.makeAJLabel("firstFrame ->")); 
			getContentPane().add(firstFrameText);
		getContentPane().add(wmk.makeAJLabel("lastFrame ->")); 
			getContentPane().add(lastFrameText);
		getContentPane().add(wmk.makeAJLabel("zoomFactor ->")); 
			getContentPane().add(zoomText);
		getContentPane().add(qualButton);
			getContentPane().add(wmk.makeAJLabel("  jpegs")); 
		rr += 30; gg -= 30; bb+=21;
		getContentPane().add(wmk.makeAJButton("do it",rr,gg,bb));
		setVisible(true);
		setLocation(490,350);
		addWindowListener(this);
  		}

	public void flash() {
		if(ifdead)
			return;
		setVisible(true);
		if(leftSet) {
			flash1.setText("respond");
			flash2.setText("please");
			setLocation(495,350);
			leftSet=false;
			}
		else  {
			flash2.setText("respond");
			flash1.setText("please");
			setLocation(490,350);
			leftSet=true;
			}
		}

// catch button and menu events...
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
    	int in1,in2;
    	double zm=1.;
	    	if(arg.equals("do it")) {
	    		// get the parameter values, set them in picJPanel, and dispose
	    		in1 = (int)(Double.valueOf(firstFrameText.getText()).doubleValue());
	    		if(in1<0) in1=0;
	    		in2 = (int)(Double.valueOf(lastFrameText.getText()).doubleValue());
	    		if(in2>=maxframes) in2=maxframes-1;
	    		if(in2<=0) in2=1;
	    		if(in1>in2)
	    			in1=in2;
	    		picJPanel.movieJFrameNum = in1;
	    		picJPanel.movieStopJFrame = in2;
	    		zm = Double.valueOf(zoomText.getText()).doubleValue();
	    		if(zm<.15) zm=.15;
	    		if(zm>2.) zm=2.;
	    		picJPanel.jpegZoomFac = zm;
	    		picJPanel.jpegQuality = jqual;
	    		ifdead = true;
	    		setVisible(false);
	    		picJPanel=null;
	    		dispose();
    			}
	    	else if(arg.equals("perfect")) {
	    		jqual = 1;
				qualButton.setLabel("excellent");
				return; 
    			}
	    	else if(arg.equals("excellent")) {
	    		jqual = 2;
				qualButton.setText("good");
				return; 
    			}
	    	else if(arg.equals("good")) {
	    		jqual = 0;
				qualButton.setText("perfect");
				return; 
    			}
   		}

	public void finalize() {
		talk("                                                         SetMovieFrameParms() snuffs");
		}
		
	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
		
// catch WindowListener events  
	public void windowActivated(java.awt.event.WindowEvent event) {
		// talk("window activated");
		}
	public void windowDeactivated(java.awt.event.WindowEvent event) {
		//  talk("window Deactivated");
		}
	public void windowOpened(java.awt.event.WindowEvent event) {}
	public void windowIconified(java.awt.event.WindowEvent event) {}
	public void windowDeiconified(java.awt.event.WindowEvent event) {}
	public void windowClosing(java.awt.event.WindowEvent event) {
		talk("You cannot close this window except by clicking the 'do it' button");
	    setVisible(true);
		}
	public void windowClosed(java.awt.event.WindowEvent event) {
		}
			    
}

