package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;


class ShowDeconSectionStatus extends JFrame {
	int [][] states=null;
	JTextField [][] labels=null;
	int nlines=-1,sectsPerLine=30;
	JLabel headline1 = null,headline2 = null;
	int sectsInStack=1;
	Color [] stateColors = {Color.blue, Color.red, Color.green, Color.black};
	int nomheight,nomwidth;
	
/* when a single computer is doing all the deconvolution, this displays thee status of the
several LightSuckerClients */
	public void sepuku() {
		for(int i=0;i<nlines;i++) 
			for(int j=0;j<sectsPerLine;j++) {
				labels[i][j]=null;
				}
		labels=null;
		states=null;
		headline1=null;
		headline2=null;
		dispose();
		}
	
	public void report(String headline,int startSection,int stopSection,int [] ifDeconCalculationDone) {
		int i,j=0,ln=0;
		String stg="";
		for(i=0;i<sectsInStack;i++) {
			if(i>= startSection && i<stopSection && ifDeconCalculationDone[i] != states[ln][j]) { // update only what changes
				states[ln][j] = ifDeconCalculationDone[i];
				labels[ln][j].setText(""+states[ln][j]);
				labels[ln][j].setBackground(stateColors[states[ln][j]]);
				}
			++j;
			if(j>=sectsPerLine) {
				++ln;
				j=0;
				}
			}	
		headline2.setText(headline);	
		}
	
	public void showHeadline(String stg) {
		headline1.setText(stg);	
		}
									
	public ShowDeconSectionStatus(int sectsInStack) {
		WidgetMaker wmk = new WidgetMaker(this);
		int i,j,ln;
		this.sectsInStack = sectsInStack;
		
		setTitle("deconvolution status of sections");
		talk("ShowDeconSectionStatus(): has sectsInStack == "+sectsInStack);
		nlines = 1+sectsInStack/sectsPerLine;
		states = new int[nlines][sectsPerLine];
		labels = new JTextField[nlines][sectsPerLine];
		String stg;
		
		getContentPane().setLayout(new GridLayout(0,1));
		headline1 = wmk.makeAJLabel("Stack has "+sectsInStack+" sections");
		headline2 = wmk.makeAJLabel("watch this space too");
		getContentPane().add(headline1);
		getContentPane().add(headline2);
		
		JPanel pan = new JPanel();
		pan.setLayout(new GridLayout(1,0));
		j=0;
		for(i=0;i<sectsPerLine;i++) { // make the section numbering line
			pan.add(wmk.makeAJTextField(""+j,1,Color.cyan) );
			++j;
			if(j>9) j=0;
			}
		getContentPane().add(pan);
		
		j=0;
		ln=0;
		pan = new JPanel();
		pan.setLayout(new GridLayout(1,0));
		for(i=0;i<sectsInStack;i++) {
			states[ln][j] = 3;
			labels[ln][j] = wmk.makeAJTextField(""+states[ln][j],1, stateColors[states[ln][j]]);
			pan.add(labels[ln][j]);
			++j;
			if(j>=sectsPerLine) {
				getContentPane().add(pan);
				talk("ShowDeconSectionStatus(): added panel for line "+ln+" of status boxes");
				pan = new JPanel();
				pan.setLayout(new GridLayout(1,0));
				j=0; ++ln;
				}
			}
			
		if(j>0) {	// fill out the row of boxes
			while(j<sectsPerLine) {
					pan.add( wmk.makeAJTextField(" ",1, Color.gray) );
					++j;
					}
			getContentPane().add(pan);
			talk("ShowDeconSectionStatus(): added panel for line "+ln+" of status boxes");
			}
			
   		wmk=null;
		nomheight = (15*nlines+60);
		nomwidth = 12*(1+sectsPerLine);
		setSize(nomwidth,nomheight);
		talk(" set window size to ("+nomwidth+", "+nomheight+")");
		setVisible(true);
		}
				
	static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}
		
}
