package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.awt.*;  
import javax.swing.*;
import java.util.*;
import java.lang.*;
import java.io.*;

public class Stringer {
	final static String [] blanks = {""," ", "  ", "   ","    ","     ","      ","       ",
			"        ","         ","          "};
	// this is meant to extend String, but evidently that is not allowed. Thus 
	// extend it manually.
	
public String append(String before,String suffix) {
	return(before+suffix);
	}
	
public String appendNumber(String before, int theNumber, int fieldWidth) {
	String theString = Integer.toString(theNumber);
	int blanksToAdd=fieldWidth - theString.length();
	return before+theString+addblanks(blanksToAdd);
	}	
	
public String appendNumber(String before, double theNumber, int decPlaces, int fieldWidth,
			boolean iftalk) {
	String stg = appendNumber(before,  theNumber,  decPlaces,  fieldWidth);
	talk("appendNumber makes <"+stg+"> from "+theNumber);
	return stg;
	}
			
public String appendNumber(String before, double theNumber, int decPlaces, int fieldWidth) {
	boolean ifNeg = (theNumber<0);
	theNumber = Math.abs(theNumber);
	int intpart = (int)theNumber;
	int ithdigit;
	String theString;
	if(ifNeg) theString="-"+intpart+".";
	else theString=""+intpart+".";
	theNumber -= intpart;
	for(int i=1; i <= decPlaces; i++) {
		theNumber = 10*theNumber;
		ithdigit = (int)theNumber;
		theNumber = theNumber - (int)theNumber;
		theString = theString + ithdigit;
		}
	int blanksToAdd = fieldWidth - theString.length();
	return before+theString+addblanks(blanksToAdd);
	}			

private String addblanks(int nblanks) {
	int nadd;
	if(nblanks<=0) return blanks[0];
	if((nadd=nblanks)>10) nadd=10;
	String stg= blanks[nadd];
	while((nadd = nblanks-stg.length() ) > 0) {
		if(nadd>10) nadd=10;
		stg = stg+blanks[nadd];
		}
	return stg;		
	}
	
private static void talk(String stg) { // write a line on stdout
		System.out.println(stg);
		}

public String padToLength(int len,String before) {
	int nadd =len - before.length();
	if(nadd<0) talk("OOPs in Stringer.padToLength(), nadd="+nadd); 
	return (before + addblanks(nadd) );
	}
		
}