package staxx;

/* Info ...  author, copyright, bundle-type, etc */

/*  <stax program for inspecting and processing stacks of confocal micrographs from Biorad *.pic format files>
    Copyright (C) <2008>  <Garrett Odell>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;  import javax.swing.*;

class TwoColorPicker extends JFrame implements java.awt.event.ActionListener{
	int markred=128,markgreen=128,markblue=128;
	int dimred=128,dimgreen=128,dimblue=128;
	JTextField markredText, markgreenText,  markblueText;
	JTextField dimredText, dimgreenText,  dimblueText;
	JButton markColor,dimColor;
	PainterColorPicker GMOPickMarkColor, GMOPickDimColor;
	int [] rgbs;
	int nomWidth=270,nomHeight=70;
	String topRowButtonText="",botRowButtonText="",topRowsColPickerTitle="",botRowsColPickerTitle="";

	public TwoColorPicker(String title, String topRowsColPickerTitle, String topRowButtonText,
			String botRowsColPickerTitle, String botRowButtonText, int [] rgbs) {
		super(title);
		this.topRowButtonText=topRowButtonText;
		this.botRowButtonText=botRowButtonText;
		this.topRowsColPickerTitle = topRowsColPickerTitle;
		this.botRowsColPickerTitle = botRowsColPickerTitle;
		this.rgbs=rgbs;
		WidgetMaker wmk = new WidgetMaker(this);
        getContentPane().setLayout(new GridLayout(2,4)); 
        markColor=wmk.makeAJButton(topRowButtonText);
        getContentPane().add(markColor);
        getContentPane().add((markredText=wmk.makeAJTextField((""+rgbs[0]),3,wmk.lightred)));
        getContentPane().add((markgreenText=wmk.makeAJTextField((""+rgbs[1]),3,wmk.lightgreen)));
        getContentPane().add((markblueText=wmk.makeAJTextField((""+rgbs[2]),3,wmk.lightblue)));
		dimColor=wmk.makeAJButton(botRowButtonText);
        getContentPane().add(dimColor);
        
        dimredText=wmk.makeAJTextField((""+rgbs[3]),3,wmk.lightred);
        getContentPane().add(dimredText);
        dimgreenText=wmk.makeAJTextField((""+rgbs[4]),3,wmk.lightgreen);
        getContentPane().add(dimgreenText);
        dimblueText=wmk.makeAJTextField((""+rgbs[5]),3,wmk.lightblue);
        getContentPane().add(dimblueText);
        		
		setSize(nomWidth,nomHeight);
		setButtonColors();
		showYourself();
		}
		
	private void setButtonColors() {
		markColor.setForeground(new Color(255-rgbs[0],255-rgbs[1],255-rgbs[2]));
		markColor.setBackground(new Color(rgbs[0],rgbs[1],rgbs[2]));
		dimColor.setForeground(new Color(255-rgbs[3],255-rgbs[4],255-rgbs[5]));
		dimColor.setBackground(new Color(rgbs[3],rgbs[4],rgbs[5]));
		}
			
	public void actionPerformed(java.awt.event.ActionEvent event) {
		String arg = event.getActionCommand();
		if(arg.equals(topRowButtonText)) {
			showMarkColorPicker();
			}
		if(arg.equals(botRowButtonText)) {
			showDimColorPicker();
			}
		}

	public void showMarkColorPicker() {
		if(GMOPickMarkColor == null )
			GMOPickMarkColor = new PainterColorPicker(getLocation().x+nomWidth+10, getLocation().y,
				topRowsColPickerTitle, this, true, rgbs[0], rgbs[1],rgbs[2],
					markredText,markgreenText,markblueText);
		GMOPickMarkColor.setLocation(getLocation().x+nomWidth+10,getLocation().y);
		GMOPickMarkColor.setVisible(true);
		}

	public void showDimColorPicker() {
		if(GMOPickDimColor == null)
			GMOPickDimColor = new PainterColorPicker(getLocation().x+nomWidth+20+GMOPickMarkColor.nomWidth, 
					getLocation().y,
				botRowsColPickerTitle, this, false,rgbs[3], rgbs[4],rgbs[5],
					dimredText,dimgreenText,dimblueText);
		GMOPickDimColor.setLocation(getLocation().x+nomWidth+20+GMOPickMarkColor.nomWidth, 
											getLocation().y);
		GMOPickDimColor.setVisible(true);
		}
			
	public void showYourself() {
		setVisible(true);
		showMarkColorPicker();
		showDimColorPicker();
		}	
	
	public void getAllColors() {
		getFirstColors();
		getSecondColors();
		}
			
	public void getFirstColors() {
		rgbs[0] = (int)(Double.valueOf(markredText.getText()).doubleValue());	
		rgbs[1] = (int)(Double.valueOf(markgreenText.getText()).doubleValue());	
		rgbs[2] = (int)(Double.valueOf(markblueText.getText()).doubleValue());
		GMOPickMarkColor=null;
		setButtonColors();
		}

	public void getSecondColors() {
		rgbs[3] = (int)(Double.valueOf(dimredText.getText()).doubleValue());	
		rgbs[4] = (int)(Double.valueOf(dimgreenText.getText()).doubleValue());	
		rgbs[5] = (int)(Double.valueOf(dimblueText.getText()).doubleValue());
		GMOPickDimColor=null;
		setButtonColors();
		}
}